#include <stdio.h>
#include <strings.h>
#include <stdlib.h>
#include "compress.h"

#define SIZE 525501200

char header[0x100];
struct Compressor *compressor;
int fileid=0;

void saveFile(void *buf, int len){

compressor=Compressor_new(0);
Compressor_Process_int16(compressor, buf, len/2);
Compressor_delete(compressor);

char filename[50];
sprintf(filename,"sound-%.5d.wav",fileid++);
FILE *o=fopen(filename,"w");
fwrite(header,1,sizeof(header),o);
fwrite(buf,1,len,o);
fclose(o);
printf("writing %s\n",filename);
}


int main(){

signed short *in=malloc(SIZE);
fread(header,sizeof(header),1,stdin);

int size=fread(in,2,SIZE/2,stdin);

int q;
int start=-1;
int len=0;
int end=0;
int signal=0;
int silence=0;
signed short sample;

int fileid=0;

for(q=0;q<size;q++){
sample=in[q];

if(abs(sample)>1000){

if(start<0){start=q-500;}
end=q+500;
silence=0;
continue;

} else {
silence++;
if(silence>150000 && start>0){

saveFile(in+start,(end-start)*2);

/////////////////

signal=0;
len=0;
start=-1;
}
}

}

// flush
if(start>=0){
saveFile(in+start,(end-start)*2);
}


return 0;
}

