
`cp ../koni.wav koni.wav`;
#`ffmpeg -i ../Enjoy\ The\ Silence.aac -ar 44100 -ac 1 -y silence.wav`;

opendir(dd,"/PATH/TO/DIR/");
@files=grep{/\d+_\d.+\.wav/i}readdir(dd);

foreach(@files){

$file="/PATH/TO/DIR/$_";
$file=~/(\d+)_(\d+)\.wav/;

$start=$1/44100;

#if($start<36*60 || $start>40*60){next;}
#if($start<68*60+44){next;}
print " $file proc start $start\n";

`ffmpeg -i $file -ar 44100 -ac 1 -y tmp.wav`;
`cat tmp.wav | Cutter/cutter`;
`mv sound-00000.wav tmp.wav`;

$offset=$1;
$needsamples=($2-$1);
$havesamples=(-s "tmp.wav")/2-50;

$ratio=$havesamples/$needsamples;
print "Stretching $havesamples to $needsamples, ratio: $ratio\n";

print `rubberband -T $ratio tmp.wav tmp2.wav`;

# Раньше для растягивания юзалась либа SoundTouch и ее soundstretch, для подсчета ее параметров я сломал мозг, да и выяснилось, что оно глючит, пришлось делать перебор.
# Но теперь есть rubberband, который делает ровно как надо

#if((-s "tmp.wav")>$mustsize){
#$min=-200;
#$max=200;
#$lastsize=-1;
#while($max-$min>2){
#$mid=int(($max+$min)/2);
#$mid=($mid>0?"+":"").$mid;
#print "Try stretch by $mid ($min .. $max)\n";
#`SoundStretch/soundstretch tmp.wav tmp2.wav -tempo=$mid\%`;
#$nsize=-s("tmp2.wav");
#if($nsize==$lastsize){last;}
#if($nsize>$mustsize){$min=$mid;}
#if($nsize<$mustsize){$max=$mid;}
#$lastsize=$nsize;
#}
rename("tmp2.wav","tmp.wav");
#}

print "Injecting $file at $offset\n";
`Cutter/inject tmp.wav $offset koni.wav`;

}

